/// <reference types="express-serve-static-core" />
/// <reference types="multer" />
/// <reference types="node" />
import { CreateMultipartUploadCommandOutput } from '@aws-sdk/client-s3';
import { ResponseMetadata } from '@aws-sdk/client-s3/dist-es/commands';
declare type UploadInfo<T> = {
    id: string;
    filename: string;
    size: number | string;
    chunks: number;
    processing: boolean;
    metadata: ResponseMetadata;
    data: T;
    parts: Array<{
        PartNumber: number;
        ETag: string;
    }>;
};
declare class S3WithPartsStorage<T = {
    clientHash: string;
}> {
    private s3;
    constructor({ region, secret, key }: {
        region: any;
        secret: any;
        key: any;
    });
    _handleFile(_req: Express.Request, file: Express.Multer.File, callback: (err: Error, data: any) => void): Promise<void>;
    createFileToStorage(info: UploadInfo<T>): Promise<CreateMultipartUploadCommandOutput>;
    uploadFileToStorage(file: string | Buffer, info: UploadInfo<T>, partNumber: any): Promise<import("@aws-sdk/client-s3").UploadPartCommandOutput>;
    completeStorageUpload(info: UploadInfo<T>): Promise<import("@aws-sdk/client-s3").CompleteMultipartUploadCommandOutput>;
    abortStorageUpload(info: UploadInfo<T>): Promise<import("@aws-sdk/client-s3").AbortMultipartUploadCommandOutput>;
}
export declare function S3CustomStorage<T>(opts: any): S3WithPartsStorage<T>;
export {};
